diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/test/wifi-mac-ofdma-test.cc ns-3.39/src/wifi/test/wifi-mac-ofdma-test.cc
--- ns-3.38/src/wifi/test/wifi-mac-ofdma-test.cc	2023-03-16 20:54:23.872869300 -0700
+++ ns-3.39/src/wifi/test/wifi-mac-ofdma-test.cc	2023-07-05 14:23:48.129428400 -0700
@@ -1234,112 +1277,137 @@
                           navEnd + tolerance,
                           "Duration/ID in Multi-STA BlockAck is too long");
 
-    // the AP sends an MU-RTS Trigger Frame to protect the DL MU PPDU
-    NS_TEST_ASSERT_MSG_GT_OR_EQ(m_txPsdus.size(), 26, "Expected at least 26 transmitted packet");
-    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[21].psduMap.size() == 1 &&
-                           m_txPsdus[21].psduMap[SU_STA_ID]->GetHeader(0).IsTrigger() &&
-                           m_txPsdus[21].psduMap[SU_STA_ID]->GetHeader(0).GetAddr1().IsBroadcast()),
-                          true,
-                          "Expected a Trigger Frame");
-    m_txPsdus[21].psduMap[SU_STA_ID]->GetPayload(0)->PeekHeader(trigger);
-    NS_TEST_EXPECT_MSG_EQ(trigger.IsMuRts(), true, "Expected an MU-RTS Trigger Frame");
-    NS_TEST_EXPECT_MSG_EQ(trigger.GetNUserInfoFields(),
-                          4,
-                          "Expected one User Info field per station");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[21].txVector.GetChannelWidth(),
-                          m_channelWidth,
-                          "Expected the MU-RTS to occupy the entire channel width");
-    for (const auto& userInfo : trigger)
+    // if the TXOP limit is not null, MU-RTS protection is not used because the next transmission
+    // is protected by the previous MU-RTS Trigger Frame
+    if (m_txopLimit == 0)
     {
-        NS_TEST_EXPECT_MSG_EQ(+userInfo.GetMuRtsRuAllocation(),
-                              +m_muRtsRuAllocation,
-                              "Unexpected RU Allocation value in MU-RTS");
-    }
-    tEnd = m_txPsdus[20].endTx;
-    tStart = m_txPsdus[21].startTx;
-    NS_TEST_EXPECT_MSG_LT_OR_EQ(tEnd + ifs, tStart, "MU-RTS Trigger Frame sent too early");
-    tEnd = m_txPsdus[21].endTx;
-    navEnd = tEnd + m_txPsdus[21].psduMap[SU_STA_ID]->GetDuration();
-
-    // A first STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
-    NS_TEST_EXPECT_MSG_EQ(
-        (m_txPsdus[22].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
-         m_txPsdus[22].psduMap.size() == 1 &&
-         m_txPsdus[22].psduMap.begin()->second->GetNMpdus() == 1 &&
-         m_txPsdus[22].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
-        true,
-        "Expected a CTS frame");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[22].txVector.GetChannelWidth(),
-                          m_channelWidth,
-                          "Expected the CTS to occupy the entire channel width");
-
-    tStart = m_txPsdus[22].startTx;
-    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
-    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
-    ctsNavEnd = m_txPsdus[22].endTx + m_txPsdus[22].psduMap[SU_STA_ID]->GetDuration();
-    // navEnd <= ctsNavEnd < navEnd + tolerance
-    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
-    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
-
-    // A second STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
-    NS_TEST_EXPECT_MSG_EQ(
-        (m_txPsdus[23].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
-         m_txPsdus[23].psduMap.size() == 1 &&
-         m_txPsdus[23].psduMap.begin()->second->GetNMpdus() == 1 &&
-         m_txPsdus[23].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
-        true,
-        "Expected a CTS frame");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[23].txVector.GetChannelWidth(),
-                          m_channelWidth,
-                          "Expected the CTS to occupy the entire channel width");
-
-    tStart = m_txPsdus[23].startTx;
-    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
-    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
-    ctsNavEnd = m_txPsdus[23].endTx + m_txPsdus[23].psduMap[SU_STA_ID]->GetDuration();
-    // navEnd <= ctsNavEnd < navEnd + tolerance
-    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
-    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+        // the AP sends an MU-RTS Trigger Frame to protect the DL MU PPDU
+        NS_TEST_ASSERT_MSG_GT_OR_EQ(m_txPsdus.size(),
+                                    26,
+                                    "Expected at least 26 transmitted packet");
+        NS_TEST_EXPECT_MSG_EQ(
+            (m_txPsdus[21].psduMap.size() == 1 &&
+             m_txPsdus[21].psduMap[SU_STA_ID]->GetHeader(0).IsTrigger() &&
+             m_txPsdus[21].psduMap[SU_STA_ID]->GetHeader(0).GetAddr1().IsBroadcast()),
+            true,
+            "Expected a Trigger Frame");
+        m_txPsdus[21].psduMap[SU_STA_ID]->GetPayload(0)->PeekHeader(trigger);
+        NS_TEST_EXPECT_MSG_EQ(trigger.IsMuRts(), true, "Expected an MU-RTS Trigger Frame");
+        NS_TEST_EXPECT_MSG_EQ(trigger.GetNUserInfoFields(),
+                              4,
+                              "Expected one User Info field per station");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[21].txVector.GetChannelWidth(),
+                              m_channelWidth,
+                              "Expected the MU-RTS to occupy the entire channel width");
+        for (const auto& userInfo : trigger)
+        {
+            NS_TEST_EXPECT_MSG_EQ(+userInfo.GetMuRtsRuAllocation(),
+                                  +m_muRtsRuAllocation,
+                                  "Unexpected RU Allocation value in MU-RTS");
+        }
+        tEnd = m_txPsdus[20].endTx;
+        tStart = m_txPsdus[21].startTx;
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(tEnd + ifs, tStart, "MU-RTS Trigger Frame sent too early");
+        tEnd = m_txPsdus[21].endTx;
+        navEnd = tEnd + m_txPsdus[21].psduMap[SU_STA_ID]->GetDuration();
+
+        // A first STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+        NS_TEST_EXPECT_MSG_EQ(
+            (m_txPsdus[22].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+             m_txPsdus[22].psduMap.size() == 1 &&
+             m_txPsdus[22].psduMap.begin()->second->GetNMpdus() == 1 &&
+             m_txPsdus[22].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+            true,
+            "Expected a CTS frame");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[22].txVector.GetChannelWidth(),
+                              m_channelWidth,
+                              "Expected the CTS to occupy the entire channel width");
+
+        tStart = m_txPsdus[22].startTx;
+        NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+        NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+        ctsNavEnd = m_txPsdus[22].endTx + m_txPsdus[22].psduMap[SU_STA_ID]->GetDuration();
+        // navEnd <= ctsNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+        NS_TEST_EXPECT_MSG_LT(ctsNavEnd,
+                              navEnd + tolerance,
+                              "Duration/ID in CTS frame is too long");
 
-    // A third STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
-    NS_TEST_EXPECT_MSG_EQ(
-        (m_txPsdus[24].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
-         m_txPsdus[24].psduMap.size() == 1 &&
-         m_txPsdus[24].psduMap.begin()->second->GetNMpdus() == 1 &&
-         m_txPsdus[24].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
-        true,
-        "Expected a CTS frame");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[24].txVector.GetChannelWidth(),
-                          m_channelWidth,
-                          "Expected the CTS to occupy the entire channel width");
+        // A second STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+        NS_TEST_EXPECT_MSG_EQ(
+            (m_txPsdus[23].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+             m_txPsdus[23].psduMap.size() == 1 &&
+             m_txPsdus[23].psduMap.begin()->second->GetNMpdus() == 1 &&
+             m_txPsdus[23].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+            true,
+            "Expected a CTS frame");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[23].txVector.GetChannelWidth(),
+                              m_channelWidth,
+                              "Expected the CTS to occupy the entire channel width");
+
+        tStart = m_txPsdus[23].startTx;
+        NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+        NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+        ctsNavEnd = m_txPsdus[23].endTx + m_txPsdus[23].psduMap[SU_STA_ID]->GetDuration();
+        // navEnd <= ctsNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+        NS_TEST_EXPECT_MSG_LT(ctsNavEnd,
+                              navEnd + tolerance,
+                              "Duration/ID in CTS frame is too long");
 
-    tStart = m_txPsdus[24].startTx;
-    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
-    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
-    ctsNavEnd = m_txPsdus[24].endTx + m_txPsdus[24].psduMap[SU_STA_ID]->GetDuration();
-    // navEnd <= ctsNavEnd < navEnd + tolerance
-    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
-    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+        // A third STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+        NS_TEST_EXPECT_MSG_EQ(
+            (m_txPsdus[24].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+             m_txPsdus[24].psduMap.size() == 1 &&
+             m_txPsdus[24].psduMap.begin()->second->GetNMpdus() == 1 &&
+             m_txPsdus[24].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+            true,
+            "Expected a CTS frame");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[24].txVector.GetChannelWidth(),
+                              m_channelWidth,
+                              "Expected the CTS to occupy the entire channel width");
+
+        tStart = m_txPsdus[24].startTx;
+        NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+        NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+        ctsNavEnd = m_txPsdus[24].endTx + m_txPsdus[24].psduMap[SU_STA_ID]->GetDuration();
+        // navEnd <= ctsNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+        NS_TEST_EXPECT_MSG_LT(ctsNavEnd,
+                              navEnd + tolerance,
+                              "Duration/ID in CTS frame is too long");
 
-    // A fourth STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
-    NS_TEST_EXPECT_MSG_EQ(
-        (m_txPsdus[25].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
-         m_txPsdus[25].psduMap.size() == 1 &&
-         m_txPsdus[25].psduMap.begin()->second->GetNMpdus() == 1 &&
-         m_txPsdus[25].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
-        true,
-        "Expected a CTS frame");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[25].txVector.GetChannelWidth(),
-                          m_channelWidth,
-                          "Expected the CTS to occupy the entire channel width");
+        // A fourth STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+        NS_TEST_EXPECT_MSG_EQ(
+            (m_txPsdus[25].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+             m_txPsdus[25].psduMap.size() == 1 &&
+             m_txPsdus[25].psduMap.begin()->second->GetNMpdus() == 1 &&
+             m_txPsdus[25].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+            true,
+            "Expected a CTS frame");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[25].txVector.GetChannelWidth(),
+                              m_channelWidth,
+                              "Expected the CTS to occupy the entire channel width");
+
+        tStart = m_txPsdus[25].startTx;
+        NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+        NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+        ctsNavEnd = m_txPsdus[25].endTx + m_txPsdus[25].psduMap[SU_STA_ID]->GetDuration();
+        // navEnd <= ctsNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+        NS_TEST_EXPECT_MSG_LT(ctsNavEnd,
+                              navEnd + tolerance,
+                              "Duration/ID in CTS frame is too long");
 
-    tStart = m_txPsdus[25].startTx;
-    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
-    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
-    ctsNavEnd = m_txPsdus[25].endTx + m_txPsdus[25].psduMap[SU_STA_ID]->GetDuration();
-    // navEnd <= ctsNavEnd < navEnd + tolerance
-    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
-    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+        tEnd = m_txPsdus[25].endTx;
+    }
+    else
+    {
+        // insert 5 elements in m_txPsdus to align the index of the following frames in the
+        // two cases (TXOP limit null and not null)
+        m_txPsdus.insert(std::next(m_txPsdus.begin(), 21), 5, {});
+        tEnd = m_txPsdus[20].endTx;
+    }
 
     // the AP sends a DL MU PPDU
     NS_TEST_ASSERT_MSG_GT_OR_EQ(m_txPsdus.size(), 27, "Expected at least 27 transmitted packet");
@@ -1359,9 +1427,8 @@
                                     m_maxAmpduSize,
                                     "Max A-MPDU size exceeded");
     }
-    tEnd = m_txPsdus[25].endTx;
     tStart = m_txPsdus[26].startTx;
-    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "DL MU PPDU sent too early");
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(tEnd + sifs, tStart, "DL MU PPDU sent too early");
     NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "DL MU PPDU sent too late");
 
     // The Duration/ID field is the same for all the PSDUs
@@ -1907,8 +1974,8 @@
 {
     uint32_t previousSeed = RngSeedManager::GetSeed();
     uint64_t previousRun = RngSeedManager::GetRun();
-    Config::SetGlobal("RngSeed", UintegerValue(1));
-    Config::SetGlobal("RngRun", UintegerValue(1));
+    Config::SetGlobal("RngSeed", UintegerValue(2));
+    Config::SetGlobal("RngRun", UintegerValue(2));
     int64_t streamNumber = 10;
 
     NodeContainer wifiApNode;
@@ -2053,6 +2120,13 @@
                                                          : WIFI_STANDARD_80211be);
     m_staDevices = NetDeviceContainer(m_staDevices, wifi.Install(phy, mac, wifiNewStaNodes));
 
+    // create a listening VHT station
+    wifi.SetStandard(WIFI_STANDARD_80211ac);
+    wifi.Install(phy, mac, Create<Node>());
+
+    wifi.SetStandard(m_scenario == WifiOfdmaScenario::HE ? WIFI_STANDARD_80211ax
+                                                         : WIFI_STANDARD_80211be);
+
     mac.SetType("ns3::ApWifiMac", "BeaconGeneration", BooleanValue(true));
     mac.SetMultiUserScheduler(
         "ns3::TestMultiUserScheduler",
@@ -2222,7 +2296,7 @@
             AddTestCase(new OfdmaAckSequenceTest(20,
                                                  WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE,
                                                  10000,
-                                                 5504,
+                                                 5632,
                                                  15,
                                                  muEdcaParameterSet,
                                                  scenario),
@@ -2230,7 +2304,7 @@
             AddTestCase(new OfdmaAckSequenceTest(20,
                                                  WifiAcknowledgment::DL_MU_AGGREGATE_TF,
                                                  10000,
-                                                 5504,
+                                                 5632,
                                                  15,
                                                  muEdcaParameterSet,
                                                  scenario),
@@ -2238,7 +2312,7 @@
             AddTestCase(new OfdmaAckSequenceTest(20,
                                                  WifiAcknowledgment::DL_MU_TF_MU_BAR,
                                                  10000,
-                                                 5504,
+                                                 5632,
                                                  15,
                                                  muEdcaParameterSet,
                                                  scenario),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/test/wifi-mac-queue-test.cc ns-3.39/src/wifi/test/wifi-mac-queue-test.cc
--- ns-3.38/src/wifi/test/wifi-mac-queue-test.cc	2023-03-16 20:54:23.872869300 -0700
+++ ns-3.39/src/wifi/test/wifi-mac-queue-test.cc	2023-07-05 14:23:48.129428400 -0700
@@ -225,8 +225,8 @@
     Enqueue(rxAddr2, false, MilliSeconds(70));
     Enqueue(rxAddr2, false, MilliSeconds(75));
 
-    WifiContainerQueueId queueId1{WIFI_QOSDATA_UNICAST_QUEUE, rxAddr1, 0};
-    WifiContainerQueueId queueId2{WIFI_QOSDATA_UNICAST_QUEUE, rxAddr2, 0};
+    WifiContainerQueueId queueId1{WIFI_QOSDATA_QUEUE, WIFI_UNICAST, rxAddr1, 0};
+    WifiContainerQueueId queueId2{WIFI_QOSDATA_QUEUE, WIFI_UNICAST, rxAddr2, 0};
 
     Simulator::Schedule(MilliSeconds(25), [&]() {
         /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/test/wifi-mlo-test.cc ns-3.39/src/wifi/test/wifi-mlo-test.cc
--- ns-3.38/src/wifi/test/wifi-mlo-test.cc	2023-03-16 20:54:23.872869300 -0700
+++ ns-3.39/src/wifi/test/wifi-mlo-test.cc	2023-07-05 14:23:48.129428400 -0700
@@ -52,6 +52,7 @@
 #include <algorithm>
 #include <array>
 #include <iomanip>
+#include <optional>
 #include <sstream>
 #include <vector>
 
@@ -235,6 +236,9 @@
 
     void DoSetup() override;
 
+    /// PHY band-indexed map of spectrum channels
+    using ChannelMap = std::map<FrequencyRange, Ptr<MultiModelSpectrumChannel>>;
+
     /**
      * Uplink or Downlink direction
      */
@@ -279,11 +283,11 @@
      *
      * \param helper the given PHY helper
      * \param channels the strings specifying the operating channels to configure
-     * \param channel the created spectrum channel
+     * \param channelMap the created spectrum channels
      */
     void SetChannels(SpectrumWifiPhyHelper& helper,
                      const std::vector<std::string>& channels,
-                     Ptr<MultiModelSpectrumChannel> channel);
+                     const ChannelMap& channelMap);
 
     /**
      * Set the SSID on the next station that needs to start the association procedure.
@@ -425,7 +429,7 @@
 void
 MultiLinkOperationsTestBase::SetChannels(SpectrumWifiPhyHelper& helper,
                                          const std::vector<std::string>& channels,
-                                         Ptr<MultiModelSpectrumChannel> channel)
+                                         const ChannelMap& channelMap)
 {
     helper = SpectrumWifiPhyHelper(channels.size());
     helper.SetPcapDataLinkType(WifiPhyHelper::DLT_IEEE802_11_RADIO);
@@ -436,7 +440,12 @@
         helper.Set(linkId++, "ChannelSettings", StringValue(str));
     }
 
-    helper.SetChannel(channel);
+    // NOTE replace this for loop with the line below to use a single spectrum channel
+    // helper.SetChannel(channelMap.begin()->second);
+    for (const auto& [band, channel] : channelMap)
+    {
+        helper.AddChannel(channel, band);
+    }
 }
 
 void
@@ -444,7 +453,7 @@
 {
     RngSeedManager::SetSeed(1);
     RngSeedManager::SetRun(2);
-    int64_t streamNumber = 100;
+    int64_t streamNumber = 30;
 
     NodeContainer wifiApNode;
     wifiApNode.Create(1);
@@ -461,12 +470,14 @@
                                  "ControlMode",
                                  StringValue("HtMcs0"));
 
-    auto channel = CreateObject<MultiModelSpectrumChannel>();
+    ChannelMap channelMap{{WIFI_SPECTRUM_2_4_GHZ, CreateObject<MultiModelSpectrumChannel>()},
+                          {WIFI_SPECTRUM_5_GHZ, CreateObject<MultiModelSpectrumChannel>()},
+                          {WIFI_SPECTRUM_6_GHZ, CreateObject<MultiModelSpectrumChannel>()}};
 
     SpectrumWifiPhyHelper staPhyHelper;
     SpectrumWifiPhyHelper apPhyHelper;
-    SetChannels(staPhyHelper, m_staChannels, channel);
-    SetChannels(apPhyHelper, m_apChannels, channel);
+    SetChannels(staPhyHelper, m_staChannels, channelMap);
+    SetChannels(apPhyHelper, m_apChannels, channelMap);
 
     for (const auto& linkId : m_fixedPhyBands)
     {
@@ -537,7 +548,7 @@
     // schedule ML setup for one station at a time
     m_apMac->TraceConnectWithoutContext("AssociatedSta",
                                         MakeCallback(&MultiLinkOperationsTestBase::SetSsid, this));
-    Simulator::Schedule(Seconds(0), [&]() { m_staMacs[0]->SetSsid(Ssid("ns-3-ssid")); });
+    m_staMacs[0]->SetSsid(Ssid("ns-3-ssid"));
 }
 
 void
@@ -581,16 +592,19 @@
      *
      * \param staChannels the strings specifying the operating channels for the STA
      * \param apChannels the strings specifying the operating channels for the AP
+     * \param scanType the scan type (active or passive)
      * \param setupLinks a list of links (STA link ID, AP link ID) that are expected to be setup
      * \param fixedPhyBands list of IDs of STA links that cannot switch PHY band
      */
     MultiLinkSetupTest(std::vector<std::string> staChannels,
                        std::vector<std::string> apChannels,
+                       WifiScanType scanType,
                        std::vector<std::pair<uint8_t, uint8_t>> setupLinks,
                        std::vector<uint8_t> fixedPhyBands = {});
     ~MultiLinkSetupTest() override = default;
 
   protected:
+    void DoSetup() override;
     void DoRun() override;
 
   private:
@@ -613,6 +627,14 @@
     void CheckBeacon(Ptr<WifiMpdu> mpdu, uint8_t linkId);
 
     /**
+     * Check correctness of the given Probe Response frame.
+     *
+     * \param mpdu the given Probe Response frame
+     * \param linkId the ID of the link on which the Probe Response frame was transmitted
+     */
+    void CheckProbeResponse(Ptr<WifiMpdu> mpdu, uint8_t linkId);
+
+    /**
      * Check correctness of the given Association Request frame.
      *
      * \param mpdu the given Association Request frame
@@ -630,10 +652,13 @@
 
     /// expected links to setup (STA link ID, AP link ID)
     const std::vector<std::pair<uint8_t, uint8_t>> m_setupLinks;
+    WifiScanType m_scanType;  //!< the scan type (active or passive)
+    std::size_t m_nProbeResp; //!< number of Probe Responses received by the non-AP MLD
 };
 
 MultiLinkSetupTest::MultiLinkSetupTest(std::vector<std::string> staChannels,
                                        std::vector<std::string> apChannels,
+                                       WifiScanType scanType,
                                        std::vector<std::pair<uint8_t, uint8_t>> setupLinks,
                                        std::vector<uint8_t> fixedPhyBands)
     : MultiLinkOperationsTestBase("Check correctness of Multi-Link Setup",
@@ -641,11 +666,21 @@
                                   staChannels,
                                   apChannels,
                                   fixedPhyBands),
-      m_setupLinks(setupLinks)
+      m_setupLinks(setupLinks),
+      m_scanType(scanType),
+      m_nProbeResp(0)
 {
 }
 
 void
+MultiLinkSetupTest::DoSetup()
+{
+    MultiLinkOperationsTestBase::DoSetup();
+
+    m_staMacs[0]->SetAttribute("ActiveProbing", BooleanValue(m_scanType == WifiScanType::ACTIVE));
+}
+
+void
 MultiLinkSetupTest::DoRun()
 {
     Simulator::Schedule(MilliSeconds(500), &MultiLinkSetupTest::CheckMlSetup, this);
@@ -667,6 +702,11 @@
             CheckBeacon(mpdu, linkId);
             break;
 
+        case WIFI_MAC_MGT_PROBE_RESPONSE:
+            CheckProbeResponse(mpdu, linkId);
+            m_nProbeResp++;
+            break;
+
         case WIFI_MAC_MGT_ASSOCIATION_REQUEST:
             CheckAssocRequest(mpdu, linkId);
             break;
@@ -682,6 +722,26 @@
 
     CheckDisabledLinks();
 
+    std::size_t expectedProbeResp = 0;
+    if (m_scanType == WifiScanType::ACTIVE)
+    {
+        // the number of Probe Response frames that we expect to receive in active mode equals
+        // the number of channels in common between AP MLD and non-AP MLD at initialization
+        for (const auto& staChannel : m_staChannels)
+        {
+            for (const auto& apChannel : m_apChannels)
+            {
+                if (staChannel == apChannel)
+                {
+                    expectedProbeResp++;
+                    break;
+                }
+            }
+        }
+    }
+
+    NS_TEST_EXPECT_MSG_EQ(m_nProbeResp, expectedProbeResp, "Unexpected number of Probe Responses");
+
     Simulator::Destroy();
 }
 
@@ -697,8 +757,8 @@
                           "TA of Beacon frame is not the address of the link it is transmitted on");
     MgtBeaconHeader beacon;
     mpdu->GetPacket()->PeekHeader(beacon);
-    const auto& rnr = beacon.GetReducedNeighborReport();
-    const auto& mle = beacon.GetMultiLinkElement();
+    const auto& rnr = beacon.Get<ReducedNeighborReport>();
+    const auto& mle = beacon.Get<MultiLinkElement>();
 
     if (m_apMac->GetNLinks() == 1)
     {
@@ -744,6 +804,65 @@
 }
 
 void
+MultiLinkSetupTest::CheckProbeResponse(Ptr<WifiMpdu> mpdu, uint8_t linkId)
+{
+    NS_ABORT_IF(mpdu->GetHeader().GetType() != WIFI_MAC_MGT_PROBE_RESPONSE);
+
+    CheckAddresses(Create<WifiPsdu>(mpdu, false), MultiLinkOperationsTestBase::DL);
+
+    NS_TEST_EXPECT_MSG_EQ(
+        m_apMac->GetFrameExchangeManager(linkId)->GetAddress(),
+        mpdu->GetHeader().GetAddr2(),
+        "TA of Probe Response is not the address of the link it is transmitted on");
+    MgtProbeResponseHeader probeResp;
+    mpdu->GetPacket()->PeekHeader(probeResp);
+    const auto& rnr = probeResp.Get<ReducedNeighborReport>();
+    const auto& mle = probeResp.Get<MultiLinkElement>();
+
+    if (m_apMac->GetNLinks() == 1)
+    {
+        NS_TEST_EXPECT_MSG_EQ(rnr.has_value(),
+                              false,
+                              "RNR Element in Probe Response frame from single link AP");
+        NS_TEST_EXPECT_MSG_EQ(mle.has_value(),
+                              false,
+                              "Multi-Link Element in Probe Response frame from single link AP");
+        return;
+    }
+
+    NS_TEST_EXPECT_MSG_EQ(rnr.has_value(), true, "No RNR Element in Probe Response frame");
+    // All the other APs affiliated with the same AP MLD as the AP sending
+    // the Probe Response frame must be reported in a separate Neighbor AP Info field
+    NS_TEST_EXPECT_MSG_EQ(rnr->GetNNbrApInfoFields(),
+                          static_cast<std::size_t>(m_apMac->GetNLinks() - 1),
+                          "Unexpected number of Neighbor AP Info fields in RNR");
+    for (std::size_t nbrApInfoId = 0; nbrApInfoId < rnr->GetNNbrApInfoFields(); nbrApInfoId++)
+    {
+        NS_TEST_EXPECT_MSG_EQ(rnr->HasMldParameters(nbrApInfoId),
+                              true,
+                              "MLD Parameters not present");
+        NS_TEST_EXPECT_MSG_EQ(rnr->GetNTbttInformationFields(nbrApInfoId),
+                              1,
+                              "Expected only one TBTT Info subfield per Neighbor AP Info");
+        uint8_t nbrLinkId = rnr->GetLinkId(nbrApInfoId, 0);
+        NS_TEST_EXPECT_MSG_EQ(rnr->GetBssid(nbrApInfoId, 0),
+                              m_apMac->GetFrameExchangeManager(nbrLinkId)->GetAddress(),
+                              "BSSID advertised in Neighbor AP Info field "
+                                  << nbrApInfoId
+                                  << " does not match the address configured on the link "
+                                     "advertised in the same field");
+    }
+
+    NS_TEST_EXPECT_MSG_EQ(mle.has_value(), true, "No Multi-Link Element in Probe Response frame");
+    NS_TEST_EXPECT_MSG_EQ(mle->GetMldMacAddress(),
+                          m_apMac->GetAddress(),
+                          "Incorrect MLD address advertised in Multi-Link Element");
+    NS_TEST_EXPECT_MSG_EQ(mle->GetLinkIdInfo(),
+                          +linkId,
+                          "Incorrect Link ID advertised in Multi-Link Element");
+}
+
+void
 MultiLinkSetupTest::CheckAssocRequest(Ptr<WifiMpdu> mpdu, uint8_t linkId)
 {
     NS_ABORT_IF(mpdu->GetHeader().GetType() != WIFI_MAC_MGT_ASSOCIATION_REQUEST);
@@ -756,7 +875,7 @@
         "TA of Assoc Request frame is not the address of the link it is transmitted on");
     MgtAssocRequestHeader assoc;
     mpdu->GetPacket()->PeekHeader(assoc);
-    const auto& mle = assoc.GetMultiLinkElement();
+    const auto& mle = assoc.Get<MultiLinkElement>();
 
     if (m_apMac->GetNLinks() == 1 || m_staMacs[0]->GetNLinks() == 1)
     {
@@ -818,7 +937,7 @@
         "TA of Assoc Response frame is not the address of the link it is transmitted on");
     MgtAssocResponseHeader assoc;
     mpdu->GetPacket()->PeekHeader(assoc);
-    const auto& mle = assoc.GetMultiLinkElement();
+    const auto& mle = assoc.Get<MultiLinkElement>();
 
     if (m_apMac->GetNLinks() == 1 || m_staMacs[0]->GetNLinks() == 1)
     {
@@ -1483,7 +1602,7 @@
         client2->SetRemote(socket);
         m_sourceMac->GetDevice()->GetNode()->AddApplication(client2);
         // start during transmission of first A-MPDU, if multiple links are setup
-        client2->SetStartTime(MilliSeconds(3));
+        client2->SetStartTime(MilliSeconds(4));
         client2->SetStopTime(duration);
     }
 
@@ -2577,7 +2696,17 @@
                       {{2, 0}},
                       {})})
     {
-        AddTestCase(new MultiLinkSetupTest(staChannels, apChannels, setupLinks, fixedPhyBands),
+        AddTestCase(new MultiLinkSetupTest(staChannels,
+                                           apChannels,
+                                           WifiScanType::PASSIVE,
+                                           setupLinks,
+                                           fixedPhyBands),
+                    TestCase::QUICK);
+        AddTestCase(new MultiLinkSetupTest(staChannels,
+                                           apChannels,
+                                           WifiScanType::ACTIVE,
+                                           setupLinks,
+                                           fixedPhyBands),
                     TestCase::QUICK);
 
         for (const auto& trafficPattern : {WifiTrafficPattern::STA_TO_STA,
